searchNodes=[{"doc":"Extensible runtime configuration loader with pluggable providers","ref":"Hush.html","title":"Hush","type":"module"},{"doc":"Is the app running in release mode?","ref":"Hush.html#release_mode?/0","title":"Hush.release_mode?/0","type":"function"},{"doc":"Resolve configuration of all loaded applications","ref":"Hush.html#resolve!/0","title":"Hush.resolve!/0","type":"function"},{"doc":"Resolve a {app, [config]} tuple","ref":"Hush.html#resolve!/1","title":"Hush.resolve!/1","type":"function"},{"doc":"Utility functions to cast Strings to Elixir native types","ref":"Hush.Cast.html","title":"Hush.Cast","type":"module"},{"doc":"Cast a string to any type. Returns an {:error, :cast} tuple on failure","ref":"Hush.Cast.html#to/2","title":"Hush.Cast.to/2","type":"function"},{"doc":"Cast a string to any type. An error is returned on failure.","ref":"Hush.Cast.html#to!/2","title":"Hush.Cast.to!/2","type":"function"},{"doc":"","ref":"Hush.Cast.html#t:type_atom/0","title":"Hush.Cast.type_atom/0","type":"type"},{"doc":"","ref":"Hush.Cast.html#t:type_native/0","title":"Hush.Cast.type_native/0","type":"type"},{"doc":"This config provider can be attached to your release to run automatically on boot.","ref":"Hush.ConfigProvider.html","title":"Hush.ConfigProvider","type":"module"},{"doc":"Hugh relies on providers to resolve values that the consumer requests.You can read here on how to write your own provider.","ref":"Hush.Provider.html","title":"Hush.Provider","type":"behaviour"},{"doc":"","ref":"Hush.Provider.html#c:fetch/1","title":"Hush.Provider.fetch/1","type":"callback"},{"doc":"Fetch a vlue from a provider","ref":"Hush.Provider.html#fetch/3","title":"Hush.Provider.fetch/3","type":"function"},{"doc":"Is the provider a valid one?","ref":"Hush.Provider.html#is?/1","title":"Hush.Provider.is?/1","type":"function"},{"doc":"","ref":"Hush.Provider.html#c:load/1","title":"Hush.Provider.load/1","type":"callback"},{"doc":"Provider to resolve runtime environmental variables","ref":"Hush.Provider.SystemEnvironment.html","title":"Hush.Provider.SystemEnvironment","type":"module"},{"doc":"Replace configuration sugin provider-aware resolvers.","ref":"Hush.Resolver.html","title":"Hush.Resolver","type":"module"},{"doc":"Substitute {:hush, Hush.Provider, &quot;key&quot;, [options]} present in the the config argument.","ref":"Hush.Resolver.html#resolve/1","title":"Hush.Resolver.resolve/1","type":"function"},{"doc":"Substitute {:hush, Hush.Provider, &quot;key&quot;, [options]} present in the the config argument","ref":"Hush.Resolver.html#resolve!/1","title":"Hush.Resolver.resolve!/1","type":"function"},{"doc":"Hush Hush makes it easy to configure your application at runtime and in release mode, it can retrieve data from multiple sources and set it in your application configuration automatically.Documentation can be found at https://hexdocs.pm/hush.","ref":"readme.html","title":"Hush","type":"extras"},{"doc":"Hush can be used to inject configuration that is not known at compile time, such as environmental variables (e.g.: Heroku's PORT env var), sensitive credentials such as your database password, or any other information you need.# config/prod.exs alias Hush.Provider.{GcpSecretManager,SystemEnvironment} config :app, Web.Endpoint, http: [port: {:hush, SystemEnvironment, &quot;PORT&quot;, [cast: :integer]}] config :app, App.Repo, password: {:hush, GcpSecretManager, &quot;CLOUDSQL_PASSWORD&quot;}Hush resolves configuration from using providers, it ships with a SystemEnvironment provider which reads environmental variables, but multiple providers exist. You can also write your own easily.ProviderDescriptionLinkSystemEnvironmentReads environmental variables.GcpSecretManagerLoad secrets from Google Cloud Platform's Secret Manager.GitHub","ref":"readme.html#overview","title":"Hush - Overview","type":"extras"},{"doc":"Add hush to your list of dependencies in mix.exs:def deps do [ {:hush, &quot;~&gt; 0.2.0&quot;} ] endRun mix deps.get to install it.Some providers may need to initialize applications to function correctly. The providers will be explicit about whether they need to be loaded at startup or not. GcpSecretsManager unlike SystemEnvironment is one such example. To load the provider you need to configure it like so. Note: SystemEnvironment does not need to be loaded at startup.# config/config.exs config :hush, providers: [ GcpSecretsManager ]","ref":"readme.html#installation","title":"Hush - Installation","type":"extras"},{"doc":"Hush can be loaded in two ways, at runtime in your application, or as a Config.Provider in release mode.Loading at runtime# application.ex def start(_type, _args) do Hush.resolve!() endLoading via in release modeTo load hush as a config provider, you need to define in your releases in mix.exs.def project do [ # ... releases: [ app: [ config_providers: [{Hush.ConfigProvider, nil}] ] ] ] endIf you are using Hush in runtime and release mode, make sure to only resolve configuration in non release mode:# application.ex def start(_, _) do unless Hush.release_mode?(), do: Hush.resolve!() end","ref":"readme.html#usage","title":"Hush - Usage","type":"extras"},{"doc":"Hush will resolve any tuple in the following format into a value.{:hush, Hush.Provider, &quot;key&quot;, options \\\\ []}Hush.Provider can be any module that implements its behaviour.&quot;key&quot; is passed to the provider to retrieve the data.options is a a Keyword list with the following properties:default: any() - If the provider can't find the value, hush will return this valueoptional: boolean() - By default, Hush will raise an error if it cannot find a value and there's no default, unless you mark it as optional.cast: :string | :atom | :charlist | :float | :integer | :boolean | :module - You can ask Hush to cast the value to a Elixir native type.ExamplesBy default if a given key is not found by the provider, Hush will raise an error. To prevent this, provide a default or optional: true in the options component of the tuple.Default# config/config.exs alias Hush.Provider.SystemEnvironment config :app, url: {:hush, SystemEnvironment, &quot;HOST&quot;, default: &quot;example.domain&quot;} # result without environmental variable assert &quot;example.domain&quot; == Application.get_env(:app, :url) # result with env HOST=production.domain assert &quot;production.domain&quot; == Application.get_env(:app, :url)CastingHere we are reading the PORT environmental variable, casting it to an integer and returning it# config/config.exs alias Hush.Provider.SystemEnvironment config :app, port: {:hush, SystemEnvironment, &quot;PORT&quot;, cast: :integer, default: 4000} # result without environmental variable assert 4000 == Application.get_env(:app, :url) # result with env PORT=443 assert 443 == Application.get_env(:app, :url)Optional# config/dev.exs alias Hush.Provider.SystemEnvironment config :app, can_be_nil: {:hush, SystemEnvironment, &quot;KEY&quot;, optional: true} # result without environmental variable assert nil == Application.get_env(:app, :can_be_nil) # result with env KEY=&quot;is not nil&quot; assert &quot;is not nil&quot; == Application.get_env(:app, :can_be_nil)","ref":"readme.html#configuration-format","title":"Hush - Configuration format","type":"extras"},{"doc":"An example provider is Hush.Provider.SystemEnvironment, which reads environmental variables at runtime. Here's an example of how that provider would look in a app configuration. alias Hush.Provider.SystemEnvironment config :app, Web.Endpoint, http: [port: {:hush, SystemEnvironment, &quot;PORT&quot;, [cast: :integer, default: 4000]}]This behaviour expects two functions: load(config :: Keyword.t()) :: :ok | {:error, any()}This function is called at startup time, here you can perform any initialization you need, such as loading applications that you depend on. fetch(key :: String.t()) :: {:ok, String.t()} | {:error, :not_found} | {:error, any()}This function is called when hush is resolving a key with you provider. Ensure that you implement a {:error, :not_found} if the value can't be found as hush will replace with it a default one if the user providede one. Note: All values are required by default, so if the user did not supply a default or made it optional, hush will trigger the error, you don't need to handle that use-case.To implement that provider we can use the following code. defmodule Hush.Provider.SystemEnvironment do @moduledoc &quot;&quot;&quot; Provider to resolve runtime environmental variables &quot;&quot;&quot; @behaviour Hush.Provider @impl Hush.Provider @spec load(config :: Keyword.t()) :: :ok | {:error, any()} def load(_config), do: :ok @impl Hush.Provider @spec fetch(key :: String.t()) :: {:ok, String.t()} | {:error, :not_found} def fetch(key) do case System.get_env(key) do nil -&gt; {:error, :not_found} value -&gt; {:ok, value} end end end","ref":"readme.html#writing-your-own-provider","title":"Hush - Writing your own provider","type":"extras"},{"doc":"Hush is released under the Apache License 2.0 - see the LICENSE file.","ref":"readme.html#license","title":"Hush - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Maps can be resolved","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Announced public release","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]